#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Matwachich

 Script Function:


#ce ----------------------------------------------------------------------------

#include "GEngin.au3"
#include <Misc.au3>
Opt("MouseCoordMode", 2)

$dll = DllOpen("user32.dll")
Global $shots[1] = [0]

Global $scrW = 800, $scrH = 600
Global $avionInnertie = 300, $avionRotInnertie = 120
Global $avionMaxSpeed = 150, $avionMaxRotSpeed = 120
Global $tirParSec = 25, $tirSpeed = 1200, $coneDeTire = 2

_GEng_Start("Test", $scrW, $scrH)
; ---

$img_Avion = _GEng_ImageLoad("res\avion.png")
$img_Shot = _GEng_ImageLoad("res\tire.png")

$spr_Avion = _GEng_SpriteCreate("spr", $img_Avion)

_GEng_SpriteSetSize($spr_Avion, 64, 64)
_GEng_SpriteSetOriginEx($spr_Avion, $GEng_Origin_Mid)
_GEng_SpriteSetAngleOrigin($spr_Avion, -90)
_GEng_SpriteSetPos($spr_Avion, 400, 300)
; ---

_GEng_SpriteSetInnertie($spr_Avion, 100, 100)
_GEng_SpriteSetAngleInnertie($spr_Avion, 500)
; ---

_GEng_SpriteSetSpeed($spr_Avion, 0, 0, 150, 150)
_GEng_SpriteSetAngleSpeed($spr_Avion, 0, 150)
; ---

Global $delaiTir = 1000 / $tirParSec
Global $tmp, $shotTimer = $delaiTir
Do
	_GEng_DrawStart(0xFFFFFFFF)
	; ---
	Select ; Mouvement Avant/Arire
		Case _IsPressed('5A', $dll) ; Z
			$tmp = _GEng_AngleToVector(_GEng_SpriteGetAngle($spr_Avion), 1200)
			_GEng_SpriteSetAccel($spr_Avion, $tmp[0], $tmp[1])
		Case _IsPressed('53', $dll) ; S
			$tmp = _GEng_AngleToVector(_GEng_SpriteGetAngle($spr_Avion), 1200)
			_GEng_SpriteSetAccel($spr_Avion, -1 * $tmp[0], -1 * $tmp[1])
		Case Else
			_GEng_SpriteSetAccel($spr_Avion, 0, 0)
	EndSelect
	
	Select ; Rotation
		Case _IsPressed('51', $dll) ; Q
			_GEng_SpriteSetAngleAccel($spr_Avion, -1200)
		Case _IsPressed('44', $dll) ; D
			_GEng_SpriteSetAngleAccel($spr_Avion, 1200)
		Case Else
			_GEng_SpriteSetAngleAccel($spr_Avion, 0)
	EndSelect
	; ---
	
	If _IsPressed('01', $dll) Then ; Tire
		If TimerDiff($shotTimer) >= $delaiTir Then
			_Shot()
			$shotTimer = TimerInit()
		EndIf
	EndIf
	; ---
	
	_DrawShots()
	_GEng_SpriteDraw($spr_Avion)
	
	; simule un mouvement alatoire/instable
	$a = Random(0, 359, 1)
	$a = _GEng_AngleToVector($a, 5)
	$s = _GEng_SpriteGetSpeed($spr_Avion)
	_GEng_SpriteSetSpeed($spr_Avion, $s[0] + $a[0], $s[1] + $a[1])
	
	; ---
	_GEng_DrawEnd()
	
	$t = @Extended
	WinSetTitle($__GEng_hGui, "", "FPS: " & Round(1000/$t) & " ("& $t &") - Nbr Sprites: " & $shots[0] + 1)
	
Until GuiGetMsg() = -3

_GEng_Shutdown()
DllClose($dll)

; ---

Func _Shot()
	Local $tmp = _GEng_SpriteGetPos($spr_Avion)
	Local $posX = $tmp[0], $posY = $tmp[1]
	; ---
	Local $spr = _GEng_SpriteCreate("shot", $img_Shot)
	_GEng_SpriteSetOriginEx($spr, $GEng_Origin_Mid)
	_GEng_SpriteSetPos($spr, $posX, $posY)
	; ---
	Local $angle = _GEng_SpriteGetAngle($spr_Avion)
	If $coneDeTire = 0 Then
		$tmp = _GEng_AngleToVector($angle, $tirSpeed)
	Else
		$tmp = _GEng_AngleToVector(Random($angle - ($coneDeTire / 2), $angle + ($coneDeTire / 2), 1), $tirSpeed)
	EndIf
	_GEng_SpriteSetSpeed($spr, $tmp[0], $tmp[1])
	_GEng_SpriteSetAngle($spr, $angle)
	; ---
	_ArrayAdd($shots, $spr)
	$shots[0] += 1
EndFunc

Func _DrawShots()
	Local $pos
	For $i = $shots[0] To 1 Step -1
		_GEng_SpriteDraw($shots[$i])
		$pos = _GEng_SpriteGetPos($shots[$i])
		If $pos[0] > $scrW Or $pos[0] < 0 Or _
			$pos[1] > $scrH Or $pos[1] < 0 Then
			_ArrayDelete($shots, $i)
			$shots[0] -= 1
		EndIf
	Next
EndFunc
