#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Matwachich

 Script Function:


#ce ----------------------------------------------------------------------------

#include <GEngin.au3>
#include <Misc.au3>
Opt("MouseCoordMode", 2)
Opt("GuiOnEventMode", 1)

$dll = DllOpen("user32.dll")
$continue = 1
Global $shots[1] = [0]

Global $scrW = 800, $scrH = 600
_GEng_Start("Exemple - Tank", $scrW, $scrH)
GuiSetOnEvent(-3, "_Exit")
Func _Exit()
	$continue = 0
EndFunc
; ---

$imgTank = _GEng_ImageLoad("res\tankV1.png", 0, 0, 29, 24)
$imgCanon = _GEng_ImageLoad("res\tankV1.png", 29, 0, 29, 24)
$imgShot = _GEng_ImageLoad("res\obus.png")
$imgBalle = _GEng_ImageLoad("res\balle.png")

$sprTank = _GEng_SpriteCreate("sprTank", $imgTank)
$sprCanon = _GEng_SpriteCreate("sprCanon", $imgCanon)

_GEng_SpriteSetOrigin($sprTank, 12, 12)
_GEng_SpriteSetOrigin($sprCanon, 12, 12)

_GEng_SpriteSetPos($sprTank, 400, 300)
; ---

_GEng_SpriteSetInnertie($sprTank, 200, 200)
_GEng_SpriteSetAngleInnertie($sprTank, 400)
_GEng_SpriteSetSpeed($sprTank, 0, 0, 75, 75)
_GEng_SpriteSetAngleSpeed($sprTank, 0, 60)
; ---

$tirSpeed = 600
$tirSpeedBall = 1000
$coneTireBall = 4

$obusParSec = 1
$delaiTir1 = 1000 / $obusParSec
$ballParSec = 100
$delaiTir2 = 1000 / $ballParSec

$obusTimer = $delaiTir1
$ballTimer = $delaiTir2
; ---

While $continue
	_GEng_DrawStart()
	; ---
	$mos = MouseGetPos()
	$angle = _GEng_SpriteToPoint_Angle($sprCanon, $mos[0], $mos[1])
	_GEng_SpriteSetAngle($sprCanon, $angle)
	
	$pos = _GEng_SpriteGetPos($sprTank)
	_GEng_SpriteSetPos($sprCanon, $pos[0], $pos[1])
	; ---
	
	Select ; Mouvement Avant/Arire
		Case _IsPressed('5A', $dll) ; Z
			$tmp = _GEng_AngleToVector(_GEng_SpriteGetAngle($sprTank), 500)
			_GEng_SpriteSetAccel($sprTank, $tmp[0], $tmp[1])
		Case _IsPressed('53', $dll) ; S
			$tmp = _GEng_AngleToVector(_GEng_SpriteGetAngle($sprTank), 500)
			_GEng_SpriteSetAccel($sprTank, -1 * $tmp[0], -1 * $tmp[1])
		Case Else
			_GEng_SpriteSetAccel($sprTank, 0, 0)
	EndSelect
	
	Select ; Rotation
		Case _IsPressed('51', $dll) ; Q
			_GEng_SpriteSetAngleAccel($sprTank, -2000)
		Case _IsPressed('44', $dll) ; D
			_GEng_SpriteSetAngleAccel($sprTank, 2000)
		Case Else
			_GEng_SpriteSetAngleAccel($sprTank, 0)
	EndSelect
	
	If _IsPressed('01', $dll) Then ; Tire
		If TimerDiff($obusTimer) >= $delaiTir1 Then
			_Shot(1)
			$obusTimer = TimerInit()
		EndIf
	EndIf
	If _IsPressed('02', $dll) Then ; Tire balle
		If TimerDiff($ballTimer) >= $delaiTir2 Then
			_Shot(2)
			$ballTimer = TimerInit()
		EndIf
	EndIf
	
	_DrawShots()
	_GEng_SpriteDraw($sprTank)
	_GEng_SpriteDraw($sprCanon)
	
	; ---
	_GEng_DrawEnd()
	$t = @Extended
	WinSetTitle($__GEng_hGui, "", "Exemple - Tank - FPS: " & Round(1000/$t) & " (" & $t & ") - Shots: " & $Shots[0])
Wend

_GEng_Shutdown()
DllClose($dll)

; ---

Func _Shot($type = 1)
	Local $tmp = _GEng_SpriteGetPos($sprCanon)
	Local $posX = $tmp[0], $posY = $tmp[1]
	; ---
	Local $spr
	If $type = 1 Then ; Obus
		$spr = _GEng_SpriteCreate("shot", $imgShot)
	Else
		$spr = _GEng_SpriteCreate("shot", $imgBalle)
	EndIf
	_GEng_SpriteSetOriginEx($spr, $GEng_Origin_Mid)
	_GEng_SpriteSetPos($spr, $posX, $posY)
	; ---
	Local $angle = _GEng_SpriteGetAngle($sprCanon)
	If $type = 1 Then
		$tmp = _GEng_AngleToVector($angle, $tirSpeed)
	Else
		$tmp = _GEng_AngleToVector(Random($angle - ($coneTireBall / 2), $angle + ($coneTireBall / 2), 1), $tirSpeedBall)
	EndIf
	_GEng_SpriteSetSpeed($spr, $tmp[0], $tmp[1])
	_GEng_SpriteSetAngle($spr, $angle)
	; ---
	_ArrayAdd($shots, $spr)
	$shots[0] += 1
EndFunc

Func _DrawShots()
	Local $pos
	For $i = $shots[0] To 1 Step -1
		_GEng_SpriteDraw($shots[$i])
		$pos = _GEng_SpriteGetPos($shots[$i])
		If $pos[0] > $scrW Or $pos[0] < 0 Or _
			$pos[1] > $scrH Or $pos[1] < 0 Then
			_ArrayDelete($shots, $i)
			$shots[0] -= 1
		EndIf
	Next
EndFunc
